#include-once
#include <WinAPI.au3>

; Damit man ein bisschen schneller ins Fenster zeichnen kann via BitBlt und trotzdem GDI+ nutzen kann.

Global Const $GDI32DLL = DllOpen('gdi32.dll')
OnAutoItExitRegister(__ReleaseGDI32)
Func __ReleaseGDI32()
	DllClose($GDI32DLL)
EndFunc

Func BufferCreate($iWidth, $iHeight)
	Local $iPtr, $hDC, $hBMP, $vBUF = DllStructCreate('int hDC;int iWidth;int iHeight;int iPtr;int hBMP')
	$vBUF.hDC = _CreateNewBmp32($iWidth, $iHeight, $iPtr, $hBMP)
	$vBUF.iWidth = $iWidth
	$vBUF.iHeight = $iHeight
	$vBUF.iPtr = $iPtr
	$vBUF.hBMP = $hBMP
	Return $vBUF
EndFunc   ;==>_CreateImage

Func BufferDelete(ByRef $vBUF)
	_WinAPI_DeleteObject($vBUF.hBMP)
	_WinAPI_DeleteDC($vBUF.hDC)
	$vBUF = 0
EndFunc   ;==>_DeleteImage

; Kein Meter von Andy von vor 20 Jahren geklaut.
Func _CreateNewBmp32($iWidth, $iHeight, ByRef $ptr, ByRef $hBmp) ;erstellt leere 32-bit-Bitmap; Rckgabe DC und ptr und handle auf die Bitmapdaten
	Local $hcdc = _WinAPI_CreateCompatibleDC(0) ;Desktop-Kompatiblen DeviceContext erstellen lassen
	Local $tBMI = DllStructCreate($tagBITMAPINFO) ;Struktur der Bitmapinfo erstellen und Daten eintragen
	DllStructSetData($tBMI, "biSize", DllStructGetSize($tBMI) - 4);Structgre abzglich der Daten fr die Palette
	DllStructSetData($tBMI, "biWidth", $iWidth)
	DllStructSetData($tBMI, "biHeight", -$iHeight) ;minus =standard = bottomup
	DllStructSetData($tBMI, "biPlanes", 1)
	DllStructSetData($tBMI, "biBitCount", 32) ;32 Bit = 4 Bytes => AABBGGRR
	Local $adib = DllCall($GDI32DLL, 'ptr', 'CreateDIBSection', 'hwnd', 0, 'ptr', DllStructGetPtr($tBMI), 'uint', $DIB_RGB_COLORS, 'ptr*', 0, 'ptr', 0, 'uint', 0)
	$hBmp = $adib[0] ;hbitmap handle auf die Bitmap, auch per GDI+ zu verwenden
	$ptr = $adib[4] ;pointer auf den Anfang der Bitmapdaten, vom Assembler verwendet
	_WinAPI_SelectObject($hcdc, $hBmp) ;objekt hbitmap in DC
	Return $hcdc ;DC der Bitmap zurckgeben
EndFunc   ;==>_CreateNewBmp32